ATK_INTER
#ifndef _application_H_
#define _application_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 


/* Generic application
 */

#include <ATK.H>
#include <init.H>

class application : public ATK  {
public:
	virtual ATKregistryEntry *ATKregistry();

        virtual boolean ParseArgs(int argc,char **argv)  ;
        virtual void ReadInitFile();
        virtual boolean Start()  ;
        virtual int Run()  ;
        virtual void Stop();
        virtual boolean Fork()  ;
        virtual void PrintVersionNumber();
	virtual char **SessionCheckpoint();
    
        inline void SetFork(boolean torf) { (this->fork=(torf)); }
        inline boolean GetFork() { return (this->fork); }

        inline void SetName(char *str) { (this->name=(str)); }
        inline char * GetName() { return (this->name); }

        inline void SetForceLoad(boolean f) { ((this)->forceload=(f)); }
        inline boolean GetForceLoad() { return ((this)->forceload); }
	inline void SetErrorProc(init_fptr p) { ((this)->errorProc=(p)); }
	inline init_fptr GetErrorProc() { return ((this)->errorProc); }
        inline void SetErrorRock(long r) { ((this)->errorRock=(r)); }
        inline long GetErrorRock() { return ((this)->errorRock); }
        inline void SetMajorVersion(long mv) { ((this)->majorversion=(mv)); }
        inline long GetMajorVersion() { return ((this)->majorversion); }
        inline void SetMinorVersion(long mv) { ((this)->minorversion=(mv)); }
        inline long GetMinorVersion() { return ((this)->minorversion); }
        inline void SetPrintVersionFlag(boolean TorF) { ((this)->printversioninfo=(TorF)); }
	inline boolean GetPrintVersionFlag() { return ((this)->printversioninfo); }

	inline void SetIconic(boolean val) { ((this)->iconic=(val)); }
	inline boolean   GetIconic() { return ((this)->iconic); }
	inline char **GetInitialArgv() { return init_argv; }

    
        static void DeleteArgs(char **argv, int num);
        static char * GetATKVersion()  ;
        static application *GetStartupApplication();

	/* The following functions operate on the startup application. */
	static char **AppSessionCheckpoint();
	static char *AppGetName();
	static void AppSetName(char *s);
	static char **AppGetInitialArgv();

	application();
        
	virtual ~application();
    
        boolean fork;
        boolean forceload,readInitFile;
        char *name;
	init_fptr errorProc;
        long errorRock;
        char *fgcolor, *bgcolor;
        char *geometry;
        long majorversion, minorversion;
	boolean printversioninfo;
	boolean iconic;
	char **init_argv;	// Initial command line (NULL terminated argv)
private:
	void SaveInitArgv(int argc, char **argv);
};

#endif /* _application_H_ */
