ATK_INTER
#ifndef _dialog_H_
#define _dialog_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1991 - All Rights Reserved           *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/

#include <sbutton.H>
#define dialog_DS_VERSION 5

#include <dataobject.H>

class dialog : public  dataobject {
public:
	virtual ATKregistryEntry *ATKregistry();


    
	static boolean InitializeClass();

    
	dialog();
    
	virtual ~dialog();
    
     char * ViewName()  ;
     long Read (FILE *fp, long id)  ;
     long Write (FILE *fp, long id, int level)  ;


    inline int GetStyle() { return (sbutton::GetStyle(this->prefs)); }
    inline class text * GetText() { return ((this)->textp); }
    inline class sbutton * GetButtons() { return ((this)->buttons); }
    inline sbutton_hitfptr GetHitFunc() { return ((this)->buttons->hitfunc); }
    inline struct sbutton_prefs * GetPrefs() { return ((this)->prefs); }


    virtual void SetButtons(class sbutton *buttons);
    virtual char * GetForeground()  ;
    virtual char * GetBackground()  ;
    virtual void SetText(class text *text);
    

    class text *textp;
    class sbutton *buttons;
    struct sbutton_prefs *prefs;
};


#endif /* _dialog_H_ */
