ATK_INTER
#ifndef _init_H_
#define _init_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 

/* init.H
 * Class header file for initialization file reader.
 *
 */

#include <ATK.H>

typedef void (*init_fptr)(long rock, char *buf);

struct menus {
    struct menus *next;
    char *class_c;
    boolean inherit;
    class menulist *menulist;
    class menulist *orig;
};


class init : public ATK   {
public:
	virtual ATKregistryEntry *ATKregistry(); /* error function */
        
	init();
	
	virtual ~init();
    
        virtual class menulist * ModifyMenulist(class menulist *ml)  ;
        virtual class keystate * ModifyKeystate(class keystate *ks)  ;
        virtual class init * Duplicate()  ;
        virtual int Load(char *filename, init_fptr errorProc, long errorRock, boolean executeImmediately)  ;
        virtual void AddKeyBinding(char *class_c, boolean inherit, class keymap *keymap);
        virtual void DeleteKeyBinding(char *class_c, boolean inherit, class keymap *keymap);
        virtual void AddMenuBinding(char *class_c, boolean inherit, class menulist *menulist);
        virtual void DeleteMenuBinding(char *class_c, boolean inherit, class menulist *menulist);

    
        struct keys *keys;
        struct menus *menus;
        struct keystateList *usedKeystates;
	struct mlList *usedMenus;
	struct children *kids;
	class init *parent;
	int version;
	struct menus *buttons;	// using menulist for now.
};

#endif /* _init_H_ */
