ATK_INTER
#ifndef _matte_H_
#define _matte_H_
/* ********************************************************************** *\
 *         Copyright IBM Corporation 1988,1991 - All Rights Reserved      *
 *        For full copyright information see:'andrew/config/COPYRITE'     *
\* ********************************************************************** */

/*
	$Disclaimer: Andrew User Interface System - Binary Distribution 7.5
// 
// Permission to use, copy, modify, and distribute this software for any 
// purpose is hereby granted, provided (a) that no fee is charged for the 
// software, for the medium on which it is distributed, for the 
// distribution process, or for effort involved in making the distribution;  
// (b) that all copyright notices, this permission notice, and the 
// following disclaimer remain in these files and appear in supporting 
// documentation;  (c) that you do not translate, reverse engineer, 
// decompile, or disassemble the software; and (d) that the names of 
// IBM, Carnegie Mellon University, and other copyright holders not 
// be used in advertising or publicity pertaining to distribution of the 
// software.
// 
// CARNEGIE MELLON UNIVERSITY, IBM, AND THE OTHER 
// COPYRIGHT HOLDERS DISCLAIM ALL WARRANTIES 
// WITH REGARD TO THIS SOFTWARE, INCLUDING ALL 
// IMPLIED WARRANTIES OF MERCHANTABILITY AND 
// FITNESS.  IN NO EVENT SHALL CARNEGIE MELLON 
// UNIVERSITY, IBM, OR ANY OTHER COPYRIGHT HOLDER 
// BE LIABLE FOR ANY SPECIAL, INDIRECT OR 
// CONSEQUENTIAL DAMAGES OR ANY DAMAGES 
// WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR 
// PROFITS, WHETHER IN AN ACTION OF CONTRACT, 
// NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING 
// OUT OF OR IN CONNECTION WITH THE USE OR 
// PERFORMANCE OF THIS SOFTWARE.
//  $
*/


 

#include <view.H>

class matte : public  view {
public:
	virtual ATKregistryEntry *ATKregistry();


     void WantNewSize(class view *requestor);
     void PostMenus(class menulist *menulist);
     void FullUpdate(enum view_UpdateType type, long left, long top, long width, long right);
     void Update();
     void Print(FILE *file, char *processor, char *finalFormat, boolean topLevel);
     class view * Hit (enum view_MouseAction action, long x, long y, long numberOfClicks)  ;
     view_DSattributes DesiredSize(long width, long height, enum view_DSpass pass, long *dWidth, long *dheight)  ;
     void GetOrigin(long width, long height, long *originX, long *originY);
     void WantInputFocus(class view *requestor);
     void ReceiveInputFocus();
     void LoseInputFocus();
     void SetDataObject(class dataobject *dataobject);
     void ObservedChanged (class observable *changed, long value);
     void LinkTree(class view *parent);
     void InitChildren();
     boolean RecSearch(struct SearchPattern *pat, boolean toplevel);
     boolean RecSrchResume(struct SearchPattern *pat);
     boolean RecSrchReplace(class dataobject *text, long pos, long len);
     void PrintPSDoc(FILE *outfile, long pagew, long pageh);
     void *GetPSPrintInterface(char *printtype);
     void DesiredPrintSize(long width, long height, enum view_DSpass pass, long *desiredwidth, long *desiredheight);
     void PrintPSRect(FILE *outfile, long logwidth, long logheight, struct rectangle *visrect);
     void ChildLosingInputFocus();
     void ChildReceivingInputFocus();

    virtual void SetResizing(long key);

    virtual void RecSrchExpose(const struct rectangle &logical, struct rectangle &hit);
    
    static class matte * Create(class viewref *vr,class view *parent)  ;
    
	static boolean InitializeClass();

    
	matte();
    
	virtual ~matte();

    int desw,desh;
    class view *child;
    class viewref *ref;
    class cursor *widthcursor, *heightcursor;
    int Moving,resizing,WasMoving, WasResizing;
    class menulist *menus;
    int drawing, OldMode, sizepending;
    boolean childhasfocus;
};

#endif /* _matte_H_ */
